
      .model small,c
      .386
      .stack

      include support.asm

      GetVideoInfo PROTO :WORD

      VIDEO_INFO STRUCT
         adapter     dw ?  ; Adapter/Monitor type
         mode        dw ?  ; BIOS video mode
         rows        dw ?  ; Number of screen rows
         columns     dw ?  ; Number of screen columns
         charHeight  dw ?  ; Character height in scan lines
         activePage  dw ?  ; Current visible display page
         cursorStart dw ?  ; Cursor starting scan line
         cursorEnd   dw ?  ; Cursor ending scan line
         screenSeg   dw 0B800h   ; Color
         statusPort  dw 3DAh     ; Color
      VIDEO_INFO ENDS
      ; Values for Adapter/Monitor type (adapted from VGA DCC).      
      MDA   EQU 1
      CGA   EQU 2
      HGA   EQU 3
      EGAC  EQU 4
      EGAM  EQU 5
      VGAM  EQU 7
      VGAC  EQU 8
.data
      vi VIDEO_INFO <>      
.code
.startup
; 
      invoke GetVideoInfo,ADDR vi
      .IF vi.adapter == MDA
            print "vi.adapter = MDA",NL
      .ELSEIF vi.adapter == CGA
            print "vi.adapter = CGA",NL      
      .ELSEIF vi.adapter == HGA
            print "vi.adapter = HGA",NL
      .ELSEIF vi.adapter == EGAC
            print "vi.adapter = EGA color",NL
      .ELSEIF vi.adapter == EGAM
            print "vi.adapter = EGA mono",NL
      .ELSEIF vi.adapter == VGAM
            print "vi.adapter = VGA mono",NL
      .ELSEIF vi.adapter == VGAC
            print "vi.adapter = VGA color",NL
      .ENDIF            
      invoke w2dec,vi.mode,ADDR outBuf
      print "vi.mode  = ",ADDR outbuf,NL
      invoke w2dec,vi.rows,ADDR outBuf
      print "vi.rows = ",ADDR outbuf,NL
      invoke w2dec,vi.columns,ADDR outBuf
      print "vi.columns = ",ADDR outbuf,NL
      invoke w2dec,vi.charHeight,ADDR outBuf
      print "vi.charHeight = ",ADDR outbuf,NL
      invoke w2dec,vi.activePage,ADDR outBuf
      print "vi.activePage = ",ADDR outbuf,NL
      invoke w2dec,vi.cursorStart,ADDR outBuf
      print "vi.cursorStart = ",ADDR outbuf,NL
      invoke w2dec,vi.cursorEnd,ADDR outBuf
      print "vi.cursorEnd = ",ADDR outbuf,NL
      invoke w2hex,vi.screenSeg,ADDR outBuf
      print "vi.screenSeg = ",ADDR outbuf,"h",NL
      invoke w2hex,vi.statusPort,ADDR outBuf
      print "vi.statusPort = ",ADDR outbuf,"h",NL
      print NL,"Press any normal key to exit...",NL
      call waitkey
; 
.exit

GetVideoInfo proc uses ax bx cx dx di npvi:WORD
      ; Loads the the video configuration and status into
      ; the elements of the specified VIDEO_INFO structure.
      ;
      ; This code should correctly identify the active
      ; display subsystem in a dual display system.
      ASSUME di:PTR VIDEO_INFO
      mov   di,npvi
      mov   ax,40h
      mov   es,ax          ; es -> BIOS data area
      mov   al,es:[84h]    ; screen rows - 1
      inc   al
      cbw
      mov   [di].rows,ax
      mov   al,es:[85h]    ; scan lines per row
      cbw
      mov   [di].charHeight,ax
      mov   ah,0Fh         ; return display status
      int   10h
      push  ax
      cbw
      mov   [di].mode,ax
      pop   ax
      xchg  al,ah
      cbw
      mov   [di].columns,ax
      xor   bl,bl
      xchg  bl,bh
      mov   [di].activePage,bx
      cmp   [di].mode,7
      je    mono
      mov   [di].adapter,CGA
      mov   ah,12h         ; alternate select
      mov   bl,10h         ; return configuration info
      xor   cx,cx          ; zero adapter bits/switch settings
      int   10h
      jcxz  isCGA          ; jump if no EGA or VGA
      test  byte ptr es:[87h],1000b ; test bit 3
      jnz   isCGA          ;jump if EGA/VGA not active
      mov   [di].adapter,EGAC
      mov   ax,1A00h       ; read display combination code
      int   10h
      cmp   al,1Ah         ; 1Ah = function supported
      jne   return         ; jump if no VGA
      cmp   bl,8           ; active DCC in bl
      jne   return         ; jump if VGA (color) not active
      mov   [di].adapter,VGAC
      jmp   return
   isCGA:
      mov   [di].charHeight,8
      jmp   return
   mono:
      mov   [di].screenSeg,0B000h
      mov   [di].statusPort,3BAh
      mov   ah,12h         ;  alternate select
      mov   bl,10h         ;  return configuration info
      xor   cx,cx          ;  zero adapter bits/switch settings
      int   10h
      jcxz  isMDA_HGA      ; jump if no EGA or VGA
      test  byte ptr es:[87h],1000b ; test bit 3
      jnz   isMDA_HGA      ; jump if EGA/VGA not active
      mov   [di].adapter,EGAM
      mov   ax,1A00h       ; read display combination code
      int   10h
      cmp   al,1Ah         ; 1Ah = function supported
      jne   return         ; jump if no VGA
      cmp   bl,7           ; active DCC in bl
      jne   return         ; jump if VGA (mono) not active
      mov   [di].adapter,VGAM
      jmp   return
   isMDA_HGA:
      mov   [di].charHeight,14 ; MDA/HGA
      call HercTest
      cmp   ax,-1
      je    isHGA          ; jump if HGA
      mov   [di].adapter,MDA
      jmp   return
   isHGA:
      mov   [di].adapter,HGA
   return:
      mov   ah,3           ; read current cursor status
      xor   bx,bx          ; page 0
      int   10h
      push  cx             ; preserve cursor type
      xor   ch,ch          ; mask starting scan line
      mov   [di].cursorEnd,cx
      pop   cx             ; restore cursor type
      xor   cl,cl          ; mask ending scan line
      xchg  cl,ch
      mov   [di].cursorStart,cx
      ret
GetVideoInfo endp

HercTest proc near uses bx cx dx es
      ; Tests for Hercules adapter by detecting change
      ; in bit 7 of status byte at 3BAh (clear while vert
      ; retrace) and returns true if detected.
      mov   dx,3BAh     ; mono status port
      in    al,dx       ; get current value
      and   al,80h      ; mask off bit 7
      mov   bl,al       ; save value
      mov   ax,40h
      mov   es,ax       ; es -> BIOS data area
      mov   cl,es:[6Ch] ; LSB of tick count
      add   cl,2        ; cl = count after 1 to 2 ticks
   testLoop:
      cmp   es:[6Ch],cl ; compare current count to cl
      je    loopExit    ; exit loop if interval expired
      in    al,dx       ; get current value
      and   al,80h      ; mask off bit 7
      cmp   al,bl
      jne   isHGA       ; jump if change
      jmp   testLoop
loopExit:
      xor   ax,ax       ;set return for not HGA
      jmp   return
isHGA:
      mov   ax,-1       ;set return for HGA
return:
      ret
HercTest endp

end
